//+------------------------------------------------------------------+
//|                                                       #BL_TM.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

//de az rfolyam kts nlkl elindul lefele, s elhagyja a stopot, akkor  az expert mkdse lljon le. 
//ezt, hogy gondolod?
//ehhez a stop vonalnak hamarabb a charton kell lennie, amint az expertnek
int    vegrehajtas_probalkozas     = 3;
int    probalkozas_idokoz          = 500;

extern int Magic = 0;
extern string order_comment ="";
//az order_comment nek nincs jelentsge

extern string Sm = "stop type  0 fix lot, 1 dynamic stop, 2 fix margin";
extern int    stop_type           = 2;
extern double Risk_percent_amount = 100;
extern double minimum_lot_size    = 0;
extern double FIX_lot_size        = 0.1;


extern color Long__jelzes = Red;
extern color Short_jelzes = Blue;
int vissza_teszt_bars = 2000;

string ERR[4208]; //hibakdok
double Points;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int maxTF=0; datetime Last_Time;

int OnInit()
  {

    ERR[0]="0 Nincs hiba.";   ERR[1]="1 Ismeretelen hiba. (Esetleg tl kzeli SL/TP)";   ERR[2]="2 Common error.";  ERR[3]="3 Invalid trade parameters.";   ERR[4]="4 A szerver elfoglalt.";   ERR[5]="5 Old version of the client terminal.";   ERR[6]="6 No connection with trade server.";   ERR[7]="7 Not enough rights.";   ERR[8]="8 Too frequent requests.";   ERR[9]="9 Malfunctional trade operation.";   ERR[64]="64 Account disabled.";   ERR[65]="65 Invalid account.";   ERR[128]="128 Trade timeout.";   ERR[129]="129 rvnytelen rfolyam.";   ERR[130]="130 Hibs stop. (Esetleg a vteli megbzs a piaci r alatt van)";   ERR[131]="131 Hibs kereskedsmret.";
    ERR[132]="132 A piac zrva.";   ERR[133]="133 Trade is disabled.";   ERR[134]="134 Nincs elg fedezet.";  ERR[135]="135 Price changed.";   ERR[136]="136 Off quotes.";   ERR[137]="137 A brker elfoglalt.";   ERR[138]="138 Requote.";   ERR[139]="139 Order is locked.";   ERR[140]="140 Long positions only allowed.";   ERR[141]="141 Too many requests.";   ERR[145]="145 Modification denied because an order is too close to market.";  
    ERR[146]="146 Trade context is busy.";   ERR[147]="147 Expirations are denied by broker.";   ERR[148]="148 The amount of opened and pending orders has reached the limit set by a broker.";  
    ERR[4000]="4000 No error."; ERR[4001]="4001 Wrong function pointer."; ERR[4002]="4002 Array index is out of range."; ERR[4003]="4003 No memory for function call stack."; ERR[4004]="4004 Recursive stack overflow."; ERR[4005]="4005 Not enough stack for parameter."; ERR[4006]="4006 No memory for parameter string."; ERR[4007]="4007 No memory for temp string."; ERR[4008]="4008 Not initialized string."; ERR[4009]="4009 Not initialized string in an array."; ERR[4010]="4010 No memory for an array string."; ERR[4011]="4011 Too long string."; ERR[4012]="4012 Remainder from zero divide."; ERR[4013]="4013 Zero divide."; ERR[4014]="4014 Unknown command."; ERR[4015]="4015 Wrong jump.";
    ERR[4016]="4016 Not initialized array."; ERR[4017]="4017 DLL calls are not allowed."; ERR[4018]="4018 Cannot load library."; ERR[4019]="4019 Cannot call function."; ERR[4020]="4020 EA function"; ERR[4021]="4021 Not enough memory for a string returned from a function."; ERR[4022]="4022 System is busy."; ERR[4050]="4050 Invalid function parameters count."; ERR[4051]="4051 Invalid function parameter value."; ERR[4052]="4052 String function internal error."; ERR[4053]="4053 Some array error."; ERR[4054]="4054 Incorrect series array using."; ERR[4055]="4055 Custom indicator error."; ERR[4056]="4056 Arrays are incompatible."; ERR[4057]="4057 Global variables processing error.";
    ERR[4058]="4058 Global variable not found."; ERR[4059]="4059 Function is not allowed in testing mode."; ERR[4060]="4060 Function is not confirmed."; ERR[4061]="4061 Mail sending error."; ERR[4062]="4062 String parameter expected."; ERR[4063]="4063 Integer parameter expected."; ERR[4064]="4064 Double parameter expected."; ERR[4065]="4065 Array as parameter expected."; ERR[4066]="4066 Requested history data in updating state."; ERR[4067]="4067 Some error in trade operation execution."; ERR[4099]="4099 End of a file."; ERR[4100]="4100 Some file error."; ERR[4101]="4101 Wrong file name."; ERR[4102]="4102 Too many opened files."; ERR[4103]="4103 Cannot open file."; 
    ERR[4104]="4104 Incompatible access to a file."; ERR[4105]="4105 No order selected."; ERR[4106]="4106 Unknown symbol."; ERR[4107]="4107 Invalid price."; ERR[4108]="4108 Invalid ticket."; ERR[4109]="4109 Trade is not allowed."; ERR[4110]="4110 Longs are not allowed."; ERR[4111]="4111 Shorts are not allowed."; ERR[4200]="4200 Object already exists."; ERR[4201]="4201 Unknown object property."; ERR[4202]="4202 Object does not exist."; ERR[4203]="4203 Unknown object type."; ERR[4204]="4204 No object name."; ERR[4205]="4205 Object coordinates error."; ERR[4206]="4206 No specified subwindow."; ERR[4207]="4207 Some error in object operation.";
    if (Digits==5 || Digits==3) { Points=Point; Points=Points*10; }
    else                          Points=Point; 
 
    int I=0;
    while (I<ObjectsTotal())
          {
          string N=ObjectName(I);
          if ((StringFind(N,"SGN_UP",0)!=-1) ||
              (StringFind(N,"SGN_DN",0)!=-1))
            //  (StringFind(N,"AllAverages",0)!=-1))
             {
             if (!ObjectDelete(N)) I++;
             }
             else I++;
          }
 if (vissza_teszt_bars>Bars-10) vissza_teszt_bars=Bars-10;         
 if (!IsTesting()) for (I=vissza_teszt_bars;I>0;I--) OnSGN(I,true);
      ObjectCreate("B",OBJ_LABEL,0,0,0);
    ObjectSet("B",OBJPROP_COLOR,Aqua);
    ObjectSet("B",OBJPROP_XDISTANCE,4);
    ObjectSet("B",OBJPROP_YDISTANCE,10);
       
  return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
  
extern int    Gyertyaszam     =  10;      // SuperTrend ATR Period
extern double ATR_Szorzo      =  3.0;     // SuperTrend Multiplier
extern int    Idosik          =  0;      // SuperTrend Timeframe
extern bool   Auto_Idosik     =  False;   // Select next higher TF. If TF=M15 then H1 is selected  
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+

void OnTick()
     {

     }

void OnSGN(int IX, bool OINV)
     {
     double STUp_A=iCustom(Symbol(),Period(),"# xSuperTrend MTF.ex4",Gyertyaszam,ATR_Szorzo,Idosik,Auto_Idosik,2,1+IX); 
     double STDn_A=iCustom(Symbol(),Period(),"# xSuperTrend MTF.ex4",Gyertyaszam,ATR_Szorzo,Idosik,Auto_Idosik,1,1+IX); 
     double STUp_L=iCustom(Symbol(),Period(),"# xSuperTrend MTF.ex4",Gyertyaszam,ATR_Szorzo,Idosik,Auto_Idosik,2,2+IX); 
     double STDn_L=iCustom(Symbol(),Period(),"# xSuperTrend MTF.ex4",Gyertyaszam,ATR_Szorzo,Idosik,Auto_Idosik,1,2+IX); 
//     ObjectCreate("xSuperTrend"+IntegerToString(Time[0+IX]),OBJ_ARROW,0,Time[0+IX],MAB0_A);
  //   ObjectSet   ("xSuperTrend"+IntegerToString(Time[0+IX]),OBJPROP_ARROWCODE,159);
    // ObjectSet   ("xSuperTrend"+IntegerToString(Time[0+IX]),OBJPROP_COLOR,Yellow);
     //ObjectSet   ("xSuperTrend"+IntegerToString(Time[0+IX]),OBJPROP_PRICE1,MAB0_A);
//     Print(""+STUp_A); //2014.05.26 10:30:34.328	#BL_ST1p0 EURUSD,H1: 2147483647
     if (STUp_A!=2147483647 && STUp_L==2147483647 && STUp_A<Close[IX])
        {
        ObjectCreate("SGN_UP"+IntegerToString(Time[0+IX]),OBJ_ARROW,0,Time[0+IX],Open[0+IX]);
        ObjectSet   ("SGN_UP"+IntegerToString(Time[0+IX]),OBJPROP_ARROWCODE,SYMBOL_ARROWUP);
        ObjectSet   ("SGN_UP"+IntegerToString(Time[0+IX]),OBJPROP_COLOR,Long__jelzes);
        ObjectSet   ("SGN_UP"+IntegerToString(Time[0+IX]),OBJPROP_PRICE1,Open[0+IX]);
        }
     if (STDn_A!=2147483647 && STDn_L==2147483647 && STDn_A>Close[IX])
        {
        ObjectCreate("SGN_DN"+IntegerToString(Time[0+IX]),OBJ_ARROW,0,Time[0+IX],Open[0+IX]);
        ObjectSet   ("SGN_DN"+IntegerToString(Time[0+IX]),OBJPROP_ARROWCODE,SYMBOL_ARROWDOWN);
        ObjectSet   ("SGN_DN"+IntegerToString(Time[0+IX]),OBJPROP_COLOR,Short_jelzes);
        ObjectSet   ("SGN_DN"+IntegerToString(Time[0+IX]),OBJPROP_PRICE1,Open[0+IX]);
        }
return;
/*
     if (Last_Time>=iTime(Symbol(),maxTF,0) && OINV==false) 
        {
     if      (Last_Irany==OP_BUY)
             {
             ObjectSetText("B","Magic: "+IntegerToString(Magic)+" Vehetek. nincs gyertyavlts TF:"+maxTF);
             }
     else if (Last_Irany==OP_SELL)
             {
             ObjectSetText("B","Magic: "+IntegerToString(Magic)+" Eladhatok. nincs gyertyavlts TF:"+maxTF);
             }
     else 
             {
             ObjectSetText("B","Magic: "+IntegerToString(Magic)+" Nem kereskedem! nincs gyertyavlts TF:"+maxTF);
             }
        return;
        }
     Last_Time=iTime(Symbol(),maxTF,0);
     
     bool last_indi_UP=false; if ((MAB2_L!=2147483647 && Mit_figyeljen!=0) || (CCI_L<=0 && Mit_figyeljen!=1)) last_indi_UP=true;
     if ( //buy
        (Last_Irany==OP_BUY || OINV==true) &&
        (last_indi_UP==true) && //csak az egyiknak kell most vltani
        ((Mit_figyeljen==0) || (MAB1_A!=2147483647)) 
         &&
        ((Mit_figyeljen==1) || (CCI_A>0           )) 
         &&
        ((HL_SL()>0 && HL_SL()<Close[0+IX]) || OINV==true)
         &&
        (figyelje_a_gyertya_iranyat==false || Open[1+IX]<Close[1+IX]) 
         &&
        (Gyertya_meret_figyelese_be==false || High[1+IX]-Open[1+IX]<=ATR_A) //Illetve figyelje azt, hogy a jelet ad gyertya mrte mekkora (nyit s a high rtke longnl, nyit s low rtke shortnl ne legyen nagyobb, mint egy megadott ATR  rtke)
         ) 
        {
        ObjectCreate("SGN_UP"+IntegerToString(Time[0+IX]),OBJ_ARROW,0,Time[0+IX],Open[0+IX]);
        ObjectSet   ("SGN_UP"+IntegerToString(Time[0+IX]),OBJPROP_ARROWCODE,SYMBOL_ARROWUP);
        ObjectSet   ("SGN_UP"+IntegerToString(Time[0+IX]),OBJPROP_COLOR,Long__jelzes);
        ObjectSet   ("SGN_UP"+IntegerToString(Time[0+IX]),OBJPROP_PRICE1,Open[0+IX]);
        if (OINV==false) //nem az initben vagyunk
           {
           
           double Lots=pozX(Symbol(),Ask-SL,Risk_percent_amount,stop_type,FIX_lot_size,minimum_lot_size);
           int TicNo=BuyVegrehajtV2(Symbol(),OP_BUY,Magic,Ask,Lots,0,order_comment,2);
           if (TicNo>=0)
              {
              OrderModifiBSSLV1(Symbol(),TicNo,SL,"open SL mod");
              Alert("Nyits "+Symbol()+"-on "+Lots+" lot BUY");
              PlaySound(hangfile);
              }
           }
        }
     
     bool last_indi_DN=false; if ((MAB1_L!=2147483647 && Mit_figyeljen!=0) || (CCI_L>=0 && Mit_figyeljen!=1)) last_indi_DN=true;
     if ( //sell
        (Last_Irany==OP_SELL || OINV==true) &&
        (last_indi_DN==true) && //csak az egyiknak kell most vltani
        ((Mit_figyeljen==0) || (MAB2_A!=2147483647)) 
         &&
        ((Mit_figyeljen==1) || (CCI_A<0           )) 
         &&
        ((HL_SL()>0 && HL_SL()>Close[0+IX]) || OINV==true)
         &&
        (figyelje_a_gyertya_iranyat==false || Open[1+IX]>Close[1+IX]) 
         &&
        (Gyertya_meret_figyelese_be==false || Open[1+IX]-Low[1+IX]<=ATR_A) //Illetve figyelje azt, hogy a jelet ad gyertya mrte mekkora (nyit s a high rtke longnl, nyit s low rtke shortnl ne legyen nagyobb, mint egy megadott ATR  rtke)
         ) 
        {
        ObjectCreate("SGN_DN"+IntegerToString(Time[0+IX]),OBJ_ARROW,0,Time[0+IX],Open[0+IX]);
        ObjectSet   ("SGN_DN"+IntegerToString(Time[0+IX]),OBJPROP_ARROWCODE,SYMBOL_ARROWDOWN);
        ObjectSet   ("SGN_DN"+IntegerToString(Time[0+IX]),OBJPROP_COLOR,Short_jelzes);
        ObjectSet   ("SGN_DN"+IntegerToString(Time[0+IX]),OBJPROP_PRICE1,Open[0+IX]);
        if (OINV==false) //nem az initben vagyunk
           {
         //  double SL=HL_SL();
           double Lots=pozX(Symbol(),SL-Bid,Risk_percent_amount,stop_type,FIX_lot_size,minimum_lot_size);
           int TicNo=BuyVegrehajtV2(Symbol(),OP_SELL,Magic,Bid,Lots,0,order_comment,2);
           if (TicNo>=0)
              {
              OrderModifiBSSLV1(Symbol(),TicNo,SL,"open SL mod");
              Alert("Nyits "+Symbol()+"-on "+Lots+" lot SELL");
              PlaySound(hangfile);
              }
           }
        }*/
     }
     
//+------------------------------------------------------------------+
bool UseEquityInsteadOfBalance = false;
double pozX(string sym, double StopLoss, double RPM     , int S_tipe     , double FIX_lot_size_, double minimum_lot_size_)
       {
//       ContractSize = MarketInfo(Symbol(), MODE_LOTSIZE);
       double Size;
       if (UseEquityInsteadOfBalance) Size = AccountEquity();
       else                           Size = AccountBalance();
       double RiskMoney;
       if      (S_tipe==1) RiskMoney = Size * RPM / 100;
       else if (S_tipe==2) RiskMoney = RPM;
       else                return(FIX_lot_size_);
       if (MarketInfo(sym,MODE_TICKVALUE)==0 || MarketInfo(sym, MODE_TICKSIZE)==0 || StopLoss==0) return(minimum_lot_size_);
       double PositionSize=RiskMoney/(MarketInfo(sym,MODE_TICKVALUE)*(StopLoss/MarketInfo(sym, MODE_TICKSIZE)));
       if (PositionSize<minimum_lot_size_) return (minimum_lot_size_);
       return(PositionSize);
       }

int BuyVegrehajtV2(string Sym, int OrderTip, int Magic_, double hol, double mekkorat, int Lejar, string comm, int LotsKerekitesTizedesre)
     {  
     int ISM=0;           
     int Error=-1;
     int TicNO=-1;
     while (Error!=0 && ISM<vegrehajtas_probalkozas && mekkorat>0) 
           {
           if (OrderTip==OP_BUY) //buy
              {
              Alert(DoubleToString(mekkorat,2)+" lots os vteli pozcit nyitok "+Sym+"-n "+comm);
              TicNO=OrderSend(Sym,
                        OrderTip,
                        NormalizeDouble(mekkorat,LotsKerekitesTizedesre),
                        MarketInfo(Sym,MODE_ASK),
                        3,
                        0,
                        0,
                        comm,Magic_,0,Green);
              Error=GetLastError();
              if (Error==131)
                 {
                 mekkorat=mekkorat-0.01;
                 }
              else if (Error!=0) 
                 {
                 Alert(Sym+" nl a "+DoubleToString(mekkorat,2)+" vteli pozci nyitsnl: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
              else
                 {
                 Print(Sym+" nl a vteli pozci nyitsnl: "+ERR[Error]);
                 }
              } 
           if (OrderTip==OP_SELL) //sell
              {
              Alert(DoubleToString(mekkorat,2)+" lots os eladsi pozcit nyitok "+Sym+"-n "+comm);
              TicNO=OrderSend(Sym,
                        OrderTip,
                        NormalizeDouble(mekkorat,LotsKerekitesTizedesre),
                        MarketInfo(Sym,MODE_BID),
                        3,
                        0,
                        0,
                        comm,Magic_,0,Red);
              Error=GetLastError();
              if (Error==131)
                 {
                 mekkorat=mekkorat-0.01;
                 }
              else if (Error!=0) 
                 {
                 Alert(Sym+" nl a "+DoubleToString(mekkorat,2)+" eladsi pozci nyitsnl: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
               else
                 {
                 Print(Sym+" nl a eladsi pozci nyitsnl: "+ERR[Error]);
                 }
              } 
           if (OrderTip==OP_BUYSTOP) //buy
              {
              TicNO=OrderSend(Sym,
                        OrderTip,
                        NormalizeDouble(mekkorat,LotsKerekitesTizedesre),
                        NormalizeDouble(hol,(int)MarketInfo(Sym,MODE_DIGITS)),
                        3,
                        0,
                        0,
                        comm,Magic_,Lejar,Green);
              Error=GetLastError();
              if (Error==131)
                 {
                 mekkorat=mekkorat-0.01;
                 }
              else if (Error!=0) 
                 {
                 Alert(Sym+" nl a "+DoubleToString(mekkorat,2)+" vteli stop megbzs nyitsnl: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
              else
                 {
                 Print(Sym+" nl a vteli stop megbzs nyitsnl: "+ERR[Error]);
                 }
              } 
           if (OrderTip==OP_SELLSTOP) //sell
              {
              TicNO=OrderSend(Sym,
                        OrderTip,
                        NormalizeDouble(mekkorat,LotsKerekitesTizedesre),
                        NormalizeDouble(hol,(int)MarketInfo(Sym,MODE_DIGITS)),
                        3,
                        0,
                        0,
                        comm,Magic_,Lejar,Red);
              Error=GetLastError();
              if (Error==131)
                 {
                 mekkorat=mekkorat-0.01;
                 }
              else if (Error!=0) 
                 {
                 Alert(Sym+" nl a "+DoubleToString(mekkorat,2)+" eladsi stop megbzs nyitsnl: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
               else
                 {
                 Print(Sym+" nl a eladsi stop megbzs nyitsnl: "+ERR[Error]);
                 }
              } 
           if (OrderTip==OP_BUYLIMIT) //buy
              {
              TicNO=OrderSend(Sym,
                        OrderTip,
                        NormalizeDouble(mekkorat,LotsKerekitesTizedesre),
                        NormalizeDouble(hol,(int)MarketInfo(Sym,MODE_DIGITS)),
                        3,
                        0,
                        0,
                        comm,Magic_,Lejar,Green);
              Error=GetLastError();
              if (Error==131)
                 {
                 mekkorat=mekkorat-0.01;
                 }
              else if (Error!=0) 
                 {
                 Alert(Sym+" nl a "+DoubleToString(mekkorat,2)+" vteli limit  megbzs nyitsnl: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
              else
                 {
                 Print(Sym+" nl a vteli limit megbzs nyitsnl: "+ERR[Error]);
                 }
              } 
           if (OrderTip==OP_SELLLIMIT) //sell
              {
              TicNO=OrderSend(Sym,
                        OrderTip,
                        NormalizeDouble(mekkorat,LotsKerekitesTizedesre),
                        NormalizeDouble(hol,(int)MarketInfo(Sym,MODE_DIGITS)),
                        3,
                        0,
                        0,
                        comm,Magic_,Lejar,Red);
              Error=GetLastError();
              if (Error==131)
                 {
                 mekkorat=mekkorat-0.01;
                 }
              else if (Error!=0) 
                 {
                 Alert(Sym+" nl a "+DoubleToString(mekkorat,2)+" eladsi limit megbzs nyitsnl: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
               else
                 {
                 Print(Sym+" nl a eladsi limit megbzs nyitsnl: "+ERR[Error]);
                 }
              } 
           }
    if (Error==0) return(TicNO);
    else          return(-1);
    }

bool OrderModifiBSSLV1(string Sym, int TicNO, double S, string kihivta)
     {
     int Error=-1;
     if ((TicNO>0) && (S!=0))
        {
        if (OrderSelect(TicNO,SELECT_BY_TICKET,MODE_TRADES)==false) return(false);
        int ISM=0;           
        Error=-1;
        while (Error!=0 && ISM<vegrehajtas_probalkozas) 
              {
              if (OrderModify(OrderTicket(),
                          OrderOpenPrice(),
                          NormalizeDouble(S,(int)MarketInfo(Sym,MODE_DIGITS)),
                          NormalizeDouble(OrderTakeProfit(),(int)MarketInfo(Sym,MODE_DIGITS)),OrderExpiration(),Blue)==false) Error=1;
              Error=GetLastError();
              if (Error!=0) 
                 {
              //   if (Error>1)
                  Alert(kihivta+IntegerToString(OrderTicket())+" "+Sym+" nl az SL: "+DoubleToString(S,(int)MarketInfo(Sym,MODE_DIGITS))+" Hiba: "+ERR[Error]);
             //    else         Print(kihivta+IntegerToString(OrderTicket())+" "+Sym+" nl az SL: "+DoubleToString(S,(int)MarketInfo(Sym,MODE_DIGITS))+" Hiba: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
              else
                 {
                 Print(kihivta+IntegerToString(OrderTicket())+" "+Sym+" nl pozci SL mdostsnl: "+ERR[Error]);
                 }
              }
        }
     if (Error==0)
        {
        return(true);
        }
     return(false);
     }

bool OrderModifiBSTPV1(string Sym, int TicNO, double S, string kihivta)
     {
     int Error=-1;
     if ((TicNO>0) && (S!=0))
        {
        if (OrderSelect(TicNO,SELECT_BY_TICKET,MODE_TRADES)==false) return(false);
        int ISM=0;           
        Error=-1;
        while (Error!=0 && ISM<vegrehajtas_probalkozas) 
              {
              if (OrderModify(OrderTicket(),
                          OrderOpenPrice(),
                          NormalizeDouble(OrderStopLoss(),(int)MarketInfo(Sym,MODE_DIGITS)),
                          NormalizeDouble(S,(int)MarketInfo(Sym,MODE_DIGITS)),OrderExpiration(),Blue)==false) Error=1;
              Error=GetLastError();
              if (Error!=0) 
                 {
              //   if (Error>1)
                  Alert(kihivta+IntegerToString(OrderTicket())+" "+Sym+" nl az TP: "+DoubleToString(S,(int)MarketInfo(Sym,MODE_DIGITS))+" Hiba: "+ERR[Error]);
               //  else         Print(kihivta+IntegerToString(OrderTicket())+" "+Sym+" nl az TP: "+DoubleToString(S,(int)MarketInfo(Sym,MODE_DIGITS))+" Hiba: "+ERR[Error]);
                 ISM++;
                 Sleep(probalkozas_idokoz);
                 RefreshRates();
                 }
              else
                 {
                 Print(kihivta+IntegerToString(OrderTicket())+" "+Sym+" nl pozci TP mdostsnl: "+ERR[Error]);
                 }
              }
        }
     if (Error==0)
        {
        return(true);
        }
     return(false);
     } 